//trigger the move
addHook("AbilitySpecial", function(p)
	if p.mo and p.mo.valid and p.mo.skin == "trip" then
		if p.pflags ~= 1|PF_THOKKED then
			p.mo.state = S_TRIP_CLINGJUMP
			S_StartSound(p.mo, sfx_cdfm46)
			P_SetObjectMomZ(p.mo, 8*FRACUNIT)
			p.pflags = 1|PF_THOKKED
		end
	end
end)

//cling to the wall
addHook("PlayerThink", function(p)
	if p.mo and p.mo.valid and p.mo.skin == "trip" then
		if p.powers[pw_pushing] == 1 and p.mo.state == S_TRIP_CLINGJUMP then
			p.mo.state = S_TRIP_JUMPCLING
			p.tripclingspeed = 0
			print("clinging!")
		end
	end
end)

//behavior after clinging
addHook("PlayerThink", function(p)
	if p.mo and p.mo.valid and p.mo.skin == "trip" and p.mo.state == S_TRIP_JUMPCLING then
		P_SetObjectMomZ(p.mo, 0*FRACUNIT)
		P_InstaThrust(p.mo, p.mo.angle, 0*FRACUNIT)
		p.powers[pw_nocontrol] = 1
		p.pflags = 0|PF_JUMPED
	end
end)

//climbing up the wall
addHook("PlayerThink", function(p)
	if p.mo and p.mo.valid and p.mo.skin == "trip" and p.mo.state == S_TRIP_JUMPCLING then
		if input.gameControlDown(GC_FORWARD) then
			print("up")
			p.tripclingspeed = $+1
		end
	end
end)

//climbing down the wall
addHook("PlayerThink", function(p)
	if p.mo and p.mo.valid and p.mo.skin == "trip" and p.mo.state == S_TRIP_JUMPCLING then
		if input.gameControlDown(GC_BACKWARD) then
			print("down")
			p.tripclingspeed = $-1
		end
	end
end)

//other stuff with the cling/climb
addHook("PlayerThink", function(p)
	if p.mo and p.mo.valid and p.mo.skin == "trip" and p.mo.state == S_TRIP_JUMPCLING then
		P_SetObjectMomZ(p.mo, p.tripclingspeed*FRACUNIT)
	end
end)

addHook("PlayerThink", function(p)
	if p.mo and p.mo.valid and p.mo.skin == "trip" then
		if p.mo.state == S_TRIP_CLINGJUMP then
			p.sflags = 1|SF_CANBUSTWALLS
		elseif p.mo.state ~= S_TRIP_CLINGJUMP then
			p.sflags = 0|SF_CANBUSTWALLS
		end
	end
end)

//exiting the cling
addHook("PlayerThink", function(p)
	if p.mo and p.mo.valid and p.mo.skin == "trip" then
		if p.mo.state == S_TRIP_JUMPCLING then
			if p.cmd.buttons & BT_SPIN ~= 0 or p.cmd.buttons & BT_JUMP ~= 0 then
				print("jumped off")
				P_InstaThrust(p.mo, p.mo.angle, -7*FRACUNIT)
				P_SetObjectMomZ(p.mo, 5*FRACUNIT)
				p.mo.state = S_PLAY_JUMP
				p.tripclingspeed = 0
			end
		end
	end
end)